/*
	File:		proc.c

	Contains:	A simple demonstration of the Process Manager API.

	Written by: James "im" Beninghaus	

	Copyright:	Copyright  1985-1999 by Apple Computer, Inc., All Rights Reserved.

				You may incorporate this Apple sample source code into your program(s) without
				restriction. This Apple sample source code has been provided "AS IS" and the
				responsibility for its operation is yours. You are not permitted to redistribute
				this Apple sample source code as "Apple sample source code" after having made
				changes. If you're going to re-distribute the source, we require that you make
				it clear in the source that the code was descended from Apple sample source
				code, but that you've made changes.

	Change History (most recent first):
				7/27/1999	Karl Groethe	Updated for Metrowerks Codewarror Pro 2.1
											fixed I/O printf formatting bug
				

*/

#include	<Errors.h>
#include	<OSUtils.h>
#include	<Processes.h>
#include	<stdio.h>


void main (void) 
{
	
	auto	OSErr				osErr			= noErr;
	auto	ProcessSerialNumber	process;
	auto	ProcessInfoRec		procInfo;
	auto	Str255				procName;
	auto	DateTimeRec			launchDateTime;		
	        FSSpec              appFSSpec;

	InitGraf((Ptr) &qd.thePort);
	
	
	printf(
		"         Process Name                 Number        Type  Signature      Mode   Location   Size   FreeMem      Launcher         LaunchDate        ActiveTime  FileDirID VRefNum  FileName                        "                        
		"\n"
		"-------------------------------- -----------------  ----    ----       -------- -------- -------- -------- ----------------- -------------------   --------   --------  ----     --------------------------------"
		"\n"
	);
	
	process.highLongOfPSN = kNoProcess;
	process.lowLongOfPSN  = kNoProcess;
	
	procInfo.processInfoLength	        = sizeof(ProcessInfoRec);
	procInfo.processName		        = procName;
	procInfo.processAppSpec             = &appFSSpec;

	while (procNotFound != (osErr = GetNextProcess(&process))) {
		if (noErr == (osErr = GetProcessInformation(&process, &procInfo))) {
			if ('\0' == procName[1])
				procName[1] = '0';
			SecondsToDate(procInfo.processLaunchDate, &launchDateTime);
			printf(
				"%-#32s %08lx.%08lx '%c%c%c%c'  '%c%c%c%c'      %08lx %08lx %08lx %08lx %08lx.%08lx %2d/%2d/%2d %2d:%02d:%02d   %08lx   %08ld  %04d     %#s\n",
				procInfo.processName,
				procInfo.processNumber.highLongOfPSN,
				procInfo.processNumber.lowLongOfPSN,
				((char *) &procInfo.processType)[0],
				((char *) &procInfo.processType)[1],
				((char *) &procInfo.processType)[2],
				((char *) &procInfo.processType)[3],
				((char *) &procInfo.processSignature)[0],
				((char *) &procInfo.processSignature)[1],
				((char *) &procInfo.processSignature)[2],
				((char *) &procInfo.processSignature)[3],
				procInfo.processMode,
				procInfo.processLocation,
				procInfo.processSize,
				procInfo.processFreeMem,
				procInfo.processLauncher.highLongOfPSN,
				procInfo.processLauncher.lowLongOfPSN,
				launchDateTime.month,
				launchDateTime.day,
				launchDateTime.year,
				launchDateTime.hour,
				launchDateTime.minute,
				launchDateTime.second,
				procInfo.processActiveTime,
				procInfo.processAppSpec -> parID,
				procInfo.processAppSpec -> vRefNum,
				procInfo.processAppSpec -> name
			);
		}
	}
}